/*******************************************************
 *     include  : netspy.h                             *
 *     data     : 10/5/1989                            *
 *     vers.    : 1.0                                  *
 *     contenuto: definizione delle strutture dati,    *
 *                delle variabili globali, di alcu-    *
 *                ne  utili costanti e infine func-    *
 *                tion  prototyping  per il  modulo    *
 *                principale netspy.c.                 *
 *     note     :                                      *
 *******************************************************/


#include  <stdio.h>
#include  <conio.h>
#include  <dos.h>
#include  <string.h>
#include  <time.h>
#include  <stdlib.h>
#include  <process.h>

#define   TRUE  1
#define   FALSE 0

#define   FEND    0xc0
#define   FESC    0xdb
#define   TFEND   0xdc
#define   TFESC   0xdd

#define   NET_ROM 0xcf
#define   IP      0xcc

#define  MAX_LINK  10   /* Dimensione massima tabella di visualizzazione */
#define  TIME_OUT  15   /* Vedi routine Aggiorna_Connessioni */

#define  GRAPHT_ON  TRUE

typedef  unsigned char  byte;
typedef  unsigned int   word;
typedef  unsigned char  boolean;
typedef  struct date    date_s;
typedef  struct time    time_s;

struct  digi_struct {
   byte   digipeater[10];
   struct digi_struct  *next;
};

typedef  struct digi_struct  digi_type;
typedef  digi_type           *digi_ptr;

struct info_s {
   digi_ptr  digi_link;
   byte      link[23];
   byte      protocollo[7];
   word      num_p,
             num_coll;
   byte      a_to_bprog,
             b_to_aprog;
   word      a_to_btot,
             b_to_atot;
   date_s    data_primo,
             data_ultimo;
   time_s    ora_primo,
             ora_ultimo;
   byte      stato;
};

typedef  struct info_s  info_t;


info_t  info[MAX_LINK];

digi_ptr   first_digip; /* inizio catena digip. */
size_t     digi_size = sizeof(digi_type);

#define  NUMPAKMAX  250

struct pacchetto_s {
  byte  *pacchetto;
  word   pac_len;
};


typedef struct pacchetto_s  pac_t;

pac_t  buffer[NUMPAKMAX];

word   num_pack = 0,
       bytepid;


int   num_bytes,
      cont,
      temp,
      indice,
      i;

byte  poll,
      index,
      num_info = 0,
      destinatario[10],
      mittente[10],
      link_1[23],
      d, c, c1,
      num_digip,
      ax25[1024],
      decode,
      fine_campo,
      frame,
      num_prog,
      tipo[5],
      pid[7],
      pos1[10],
      cattura = 0,
      okprint = 1,
      ritorna = 0,
      prompt[][4] = { "OFF", "ON " },
      save[4000],
      ultimo_ric;

FILE *fp;

boolean  grapht_status;


void  Introduzione(void);
void  Gestisci_File(void);
void  Aggiorna_Connessioni(void);
void  Scrivi_Stringa(byte);
void  Scrivi_Orologio(byte, byte);
void  Visualizza_Menu(void);
void  Usa_Window1(void);
void  Usa_Window2(void);
void  Usa_FullScreen(void);
void  Mostra_Info(void);
void  Salva_Info(byte);
void  Crea_Nuovo_Link(byte, byte);
void  Esci(byte);
void  Errore(void);
void  Host_off(void);